

package mobicomp.interfaces;
import java.io.IOException;



public interface SHSocket
{

    /**
     * This address and port must be used for all communication
     * on this layer. Only clients using the same values will
     * be able to communicate with each other.
     */
    public static final String GROUP_ADDRESS = "239.0.0.1";
    public static final int COMMUNICATION_PORT = 32224; // 'dcg' in sms language

    /**
     * All clients receiving a message with this value 
     * in the receiver address field will handle the message.
     */
    public static final int BROADCAST_ADDRESS = 0;

    /**
     * Set/get our own address 
     */
    public void setOwnAddress( int addr);

    public int getOwnAddress();

    /**
     * Send a packet
     */
    public void send( Message p) throws IOException;

    /**
     * Receive a packet in a blocking way
     */
    public Message receive() throws IOException;

}

